# database: search


# xinabse_hits
DROP TABLE IF EXISTS xinabse_hits;

CREATE TABLE xinabse_hits(
	keyid int(10) unsigned NOT NULL,
	siteid int(10) unsigned NOT NULL,
	weight tinyint(4) unsigned NOT NULL,
	PRIMARY KEY (keyid, siteid)
);

# xinabse_keywords
DROP TABLE IF EXISTS xinabse_keywords;

CREATE TABLE xinabse_keywords(
	keyid int(10) unsigned NOT NULL AUTO_INCREMENT,
	twoletters char(2) NOT NULL,
	keyword varchar(32) NOT NULL,
	PRIMARY KEY (keyid),
	UNIQUE keyword_idx (keyword)
);

# xinabse_sites
DROP TABLE IF EXISTS xinabse_sites;

CREATE TABLE xinabse_sites(
	siteid int(10) unsigned NOT NULL AUTO_INCREMENT,
	domain varchar(255) NOT NULL,
	path varchar(255) NOT NULL,
	page varchar(255) NULL,
	title varchar(255) NULL,
	lastmodified datetime NOT NULL,
	level tinyint(3) unsigned NOT NULL,
	lastcheck timestamp(14) NULL,
	extract text NULL,
	startid int(10) unsigned NULL,
	PRIMARY KEY (siteid),
	INDEX domain_idx (domain),
	INDEX path_idx (path),
	INDEX page_idx (page)
);



