<?php

/**
 * submit query to xinabse
 *
 */
function xinabse($query,&$resultarray,$all=false,$offset=0,$limit=20,$domain=""){
  global $XINABSE_SERVER;
  global $XINABSE_DATABASE;
  global $XINABSE_USER;
  global $XINABSE_PASSWD;

  $query = xinabse_HTMLdecode($query);
  xinabse_debug("decoded query","'".$query."'");
  $query = strtolower($query);
  $query = preg_replace('/"/'," ",$query);
  $query = preg_replace("/'/"," ",$query);
  $query = preg_replace("/[\s\-_;,.]/"," ",$query);
  $query = preg_replace("/  /"," ",$query);
  $query = trim($query);
  xinabse_debug("trimmed query","'".$query."'");
    
  if(empty($query)) return false;
  
  $pq = split(" ",$query);

  foreach ($pq as $token){
    $op = '=';
    if (substr($token,-1,1) == '*'){
      $op = 'LIKE';
      $token = preg_replace("/\*$/","%",$token);
    }
    $where .= "OR ( (C.twoletters = '".substr($token,0,2)."') AND ";
    $where .= "     (C.keyword $op '".$token."') )\n";
  }
  $where = preg_replace("/^OR/","",$where);
  if (!empty($domain)){
    $dom = "AND A.domain = '$domain'";
  }
  
  $select = "SELECT A.domain,A.path,A.page,A.title,A.extract,
                    SUM(B.weight) as weight,COUNT(*) as cnt,
                    CONCAT('http://',A.domain,A.path,A.page) as url,
                    A.lastmodified, A.siteid
               FROM xinabse_sites A, xinabse_hits B, xinabse_keywords C
              WHERE A.siteid = B.siteid
                AND B.keyid = C.keyid
                AND ($where)
                $dom
           GROUP BY A.siteid
           ORDER BY cnt DESC, weight DESC";
  xinabse_debug("SELECT",$select);
  
  $link   = mysql_connect($XINABSE_SERVER,$XINABSE_USER,$XINABSE_PASSWD) or
            die("DB-Connection failed");
  xinabse_debug("mysql-link",$link);
  $result = mysql_db_query($XINABSE_DATABASE,$select,$link) or
            die(mysql_error());
  xinabse_debug("mysql-result",$result);
  if(!$rowcount = mysql_num_rows($result)) return 0;

  //get first row and it's weight
  $row = mysql_fetch_object($result);
  $maxweight = $row->weight;

  xinabse_debug("full rowcount","$rowcount");
  $i=0;
  while (($row = mysql_fetch_object($result))){
    if($all && ($row->cnt != count($pq))){
      $rowcount--;
      continue;
    }
    $row->number = $offset+$i+1;
    $row->relevance = round((100*$row->weight)/$maxweight);
    $resultarray[] = $row;
    $i++;
  }
  mysql_free_result($result);
  xinabse_debug("final rowcount","$rowcount");

  //jump to offset:
  $resultarray = array_slice ($resultarray,$offset,$limit);
  
  return $rowcount;
}

function xinabse_info(){
  global $XINABSE_SERVER;
  global $XINABSE_DATABASE;
  global $XINABSE_USER;
  global $XINABSE_PASSWD;

  $link   = mysql_connect($XINABSE_SERVER,$XINABSE_USER,$XINABSE_PASSWD) or die();
  xinabse_debug("mysql-link",$link);

  //start-urls
  $select = "SELECT CONCAT(  'http://', domain, path, page ) as fullurl
               FROM xinabse_sites
              WHERE startid IS  NULL
           ORDER BY fullurl";
  $result = mysql_db_query($XINABSE_DATABASE,$select,$link) or die();
  xinabse_debug("mysql-result",$result);
  $info[starturlcount] = mysql_num_rows($result);
  while($row = mysql_fetch_row($result)){
    $info[starturls][] = $row[0];
  }
  mysql_free_result($result);

  //pages
  $select = "SELECT COUNT(*)
               FROM xinabse_sites";
  $result = mysql_db_query($XINABSE_DATABASE,$select,$link) or die();
  xinabse_debug("mysql-result",$result);
  $row = mysql_fetch_row($result);
  $info[pagecount] = $row[0];
  mysql_free_result($result);

  //domains
  $select = "SELECT domain, count(*) as cnt
               FROM xinabse_sites
           GROUP BY domain
           ORDER BY cnt DESC";
  $result = mysql_db_query($XINABSE_DATABASE,$select,$link) or die();
  xinabse_debug("mysql-result",$result);
  while($row = mysql_fetch_row($result)){
    $info[domains][$row[0]] = $row[1];
  }
  
  //keywords
  $select = "SELECT COUNT(*)
               FROM xinabse_keywords";
  $result = mysql_db_query($XINABSE_DATABASE,$select,$link) or die();
  xinabse_debug("mysql-result",$result);
  $row = mysql_fetch_row($result);
  $info[keywordcount] = $row[0];
  mysql_free_result($result);

  //last update
  $select = "SELECT unix_timestamp(max(lastcheck)) FROM xinabse_sites";
  $result = mysql_db_query($XINABSE_DATABASE,$select,$link) or die();
  xinabse_debug("mysql-result",$result);
  $row = mysql_fetch_row($result);
  $info[lastupdate] = $row[0];
  mysql_free_result($result);

  return $info;
}

function xinabse_debug($desc,$msg){
  global $XINABSE_DEBUG;
  if ($XINABSE_DEBUG){
    print "\n<!-- DEBUG: $desc\n\n$msg\n\n-->\n";
  }
}

function xinabse_HTMLdecode($string) {
   $string = strtr($string, array_flip(get_html_translation_table(HTML_ENTITIES)));
   $string = preg_replace("/&#([0-9]+);/me", "chr('\\1')", $string);
   return $string;
}

?>
